SystemOrganization addCategory: #'Orca-Testing'!

OrcaTestCase subclass: #OrcaClientSideTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTestCase class methodsFor: 'configuration' stamp: 'sw 5/23/2011 11:23'!
requiredClasses

	^ { OrcaTestResult . OrcaPopup }! !

!OrcaClientSideTestCase class methodsFor: 'configuration' stamp: 'sw 5/10/2011 14:41'!
suiteClass

	 ^ OrcaClientSideTestSuite ! !

!OrcaClientSideTestCase methodsFor: 'accessing' stamp: 'sw 5/23/2011 11:27'!
add: aWidget
	
	aWidget addToWorld ! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'hk 5/17/2011 16:43'!
debug

	Error signal: 'A failure or error occured while testing. See the browser for details.'! !

!OrcaClientSideTestCase methodsFor: 'testing' stamp: 'hk 5/17/2011 16:40'!
document

	^ Js Document! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'sw 5/23/2011 12:58'!
performTest

	^ self perform:  self selector ! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'sw 5/25/2011 10:20'!
run
	"this method will be called in the image when executing single tests (e.g. in the class browser when test a method)"
	
	| session  |
	OrcaClientSideTestRunner ensureClientSideTestRunnerIsStarted.
	session := OrcaClientSideTestRunner currentSession.
	
	(session channel notNil and: [  session channel isAlive]) 
		ifTrue: [ 
		  	[ :aDictionary | Js Global testRunner executeTests: aDictionary ] 
				inSessionForked: session
				values: { {(self class name ->  self selector )} }.
			^ OrcaClientSideTestRunner testResultsFromClient.
		   ]
		ifFalse: [
			Error signal: 'No Session found!!'.
			].
! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'sw 5/23/2011 17:28'!
runCase

	| result |
	
	self setUp.
	result := self performTest.
	self tearDown.
	^ result! !

!OrcaClientSideTestCase methodsFor: 'running' stamp: 'hk 5/17/2011 16:45'!
runOnClientside
	
	| result |
	"this method will be invoked in the client to execute the tests"
	
	result := OrcaTestResult new.
	self run: result.
	^ result! !

!OrcaClientSideTestCase methodsFor: 'accessing' stamp: 'hk 5/17/2011 16:43'!
timeoutForSetUp 

	 ^ 60 * 1000! !

!OrcaClientSideTestCase methodsFor: 'accessing' stamp: 'hk 5/17/2011 16:44'!
timeoutForTest

	 ^ 60 * 1000! !

OrcaClientSideTestCase subclass: #OrcaDemoTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaDemoTests methodsFor: 'testing' stamp: 'sw 5/23/2011 10:56'!
testError

	self fail.! !

!OrcaDemoTests methodsFor: 'testing' stamp: 'sw 5/23/2011 10:56'!
testExpectedError

"	self
		should: [ Foo bar ]
		raise: Error."! !

!OrcaDemoTests methodsFor: 'testing' stamp: 'sw 5/25/2011 10:44'!
testPass
	
	self assert: true! !

!OrcaDemoTests methodsFor: 'testing' stamp: 'hk 5/17/2011 16:37'!
testSimpleFail

	self assert: false.! !

OrcaClientSideTestCase subclass: #OrcaDomTestCase
	instanceVariableNames: 'iframe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

OrcaDomTestCase subclass: #OrcaDomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaDomTest class methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2011 09:59'!
cssId

	 ^ 'text'! !

!OrcaDomTest class methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2011 14:29'!
requiredClasses 

	 ^ { SmallInteger . Interval }! !

!OrcaDomTest methodsFor: 'running' stamp: 'sw 5/24/2011 14:54'!
setUp

	| widget |

	widget := OrcaText new
		text: 'Hello World';
		cssId: self class cssId.
	widget node name: self class cssId.
	self add: widget ! !

!OrcaDomTest methodsFor: 'running' stamp: 'sw 5/24/2011 10:16'!
setUpDeferred

	| widget |
	widget := OrcaText new
		text: 'Hello World';
		cssId: self class cssId.
	widget node name: self class cssId.
	self add: widget ! !

!OrcaDomTest methodsFor: 'running' stamp: 'sw 5/23/2011 17:25'!
tearDown
	
	| |
	
	"self halt.
	
	element := Js document getElementById value: self class cssId.
	Js document body removeChild value: element."! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/17/2011 16:52'!
testElementPresence

	self assert: (self hasElement: 'span').! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/18/2011 11:41'!
testId

	self assert: (self hasElementWithId: self class cssId).! !

!OrcaDomTest methodsFor: 'testing' stamp: 'sw 5/24/2011 13:49'!
testName
	self halt.

	self assert: (self hasElementWithName: self class cssId).! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/18/2011 11:47'!
testNothing! !

!OrcaDomTest methodsFor: 'testing' stamp: 'hk 5/17/2011 17:01'!
testText

	self assert: (self hasText: 'Hello World').! !

!OrcaDomTestCase class methodsFor: 'as yet unclassified' stamp: 'hk 5/17/2011 19:45'!
requiredClasses

	 ^ OrcaWidget allSubclasses! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 11:27'!
add: aWidget

	self window add: aWidget   ! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/25/2011 09:50'!
buildIframe

	self iframe: (OrcaPopup new source: (OrcaClientSideTestRunner blankDocumentPath)).
	self iframe  addToWorld.
	! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/25/2011 09:53'!
document 

	^ self iframe contentDocument! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/25/2011 09:53'!
elementWithId: aString

	^ self document getElementById value: aString! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/25/2011 09:53'!
elementsWithName: aString

	^ self document getElementsByName value: aString! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/25/2011 09:53'!
elementsWithTag: anHtmlTag

	^ self document getElementsByTagName value: anHtmlTag! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/24/2011 13:30'!
has: aNumber elementsWithName: aString

	^ (self elementsWithName: aString) length = aNumber! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/24/2011 13:30'!
has: aNumber elementsWithTag: anHtmlTag

	^ (self elementsWithTag: anHtmlTag) length = aNumber! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/23/2011 11:39'!
hasElementWithId: aString

	^ (self elementWithId: aString) notNil! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/24/2011 13:29'!
hasElementWithName: aString

	^ (self elementsWithName: aString) length > 0! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/24/2011 13:30'!
hasElementWithTag: anHtmlTag

	^ (self elementsWithTag: anHtmlTag) length > 0 	! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/25/2011 09:53'!
hasText: aString

	^ self document find value: aString
	! !

!OrcaDomTestCase methodsFor: 'accessing' stamp: 'sw 5/25/2011 09:49'!
iframe
	^ iframe! !

!OrcaDomTestCase methodsFor: 'accessing' stamp: 'sw 5/25/2011 09:49'!
iframe: anObject
	iframe := anObject! !

!OrcaDomTestCase methodsFor: 'testing' stamp: 'sw 5/25/2011 09:50'!
runOnClientside  
	
	self buildIframe.
	^ super runOnClientside! !

OrcaSession subclass: #OrcaClientSideTestSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTestSession methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2011 08:14'!
handleChannelOpened

	super handleChannelOpened.
	OrcaClientSideTestRunner signalIncomingClientConnection.! !

TestSuite subclass: #OrcaClientSideTestSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:26'!
createCollectionOfAssociationsFrom: aCollectionOfTestCases

	| collection |
	collection := OrderedCollection new.
	aCollectionOfTestCases do: [ :each |
		collection add: (each class name -> each selector) ].
	
	^ collection.! !

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:28'!
run 
	

	OrcaClientSideTestRunner ensureClientSideTestRunnerIsStarted.
	
	tests := self createCollectionOfAssociationsFrom: self tests.
	
	OrcaClientSideTestSession allInstancesDo: 
		[ :each |
			[ :aDictionary | Js Global testRunner executeTests: aDictionary ] inSession: each values: { tests }..
		].
	
	^ OrcaClientSideTestRunner waitForTestsResults! !

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'sw 5/10/2011 14:53'!
run: aResult 
	"this method will be called when executing a bunch of tests (e.g. of whole classes in the class browser)"
	
	self halt.
	self tests do: [:each | 
		self changed: each.
		each run: aResult].
			! !

TestResult subclass: #OrcaTestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:41'!
erroneousTestcases

	^ errors! !

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:42'!
failedTestcases

	^ failures! !

!OrcaTestResult methodsFor: 'initialization' stamp: 'hk 5/17/2011 17:02'!
initialize

	super initialize.
	failures := OrderedCollection new.! !

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:41'!
passedTestcases

	^ passed! !

TestCase subclass: #OrcaMockTest
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaMockTest methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:45'!
mock
	^ mock! !

!OrcaMockTest methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:45'!
mock: anObject
	mock := anObject! !

!OrcaMockTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 09:46'!
setUp

	self mock: (OrcaMock for: (OrderedCollection new)).! !

!OrcaMockTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 09:46'!
tearDown

	self mock: nil.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:11'!
testCleanInitialization

	self assert: self mock receivedMessages isEmpty.
	self assert: self mock stubbedMessages isEmpty.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:50'!
testMessageForwarding

	self assert: (self mock stubbedMessages isEmpty).
	self mock add: true.
	self assert: self mock mockedObject size = 1! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:48'!
testMockedObject

	self assert: self mock mockedObject isCollection.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:19'!
testReceived

	self mock add: 1.
	self assert: (self mock received: #add:).
	self assert: (self mock received: #add: withArgs: { 1}).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:22'!
testReceivedAtLeast

	self deny: (self mock received: #add: atLeast: 1).
	self mock add: 1.
	self assert: (self mock received: #add: atLeast: 1).
	self deny: (self mock received: #add: atLeast: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:23'!
testReceivedAtMost

	self assert: (self mock received: #add: atMost: 1).
	self mock
		add: 1;
		add: 2..
	self deny: (self mock received: #add: atMost: 1).
	self assert: (self mock received: #add: atMost: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:23'!
testReceivedTimes

	self deny: (self mock received: #add: times: 1).
	self mock add: 1.
	self assert: (self mock received: #add: times: 1).
	self deny: (self mock received: #add: times: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:17'!
testStubReturnValue

	self mock stub: #add: andReturn: true.
	self assert: (self mock add: 1 = true).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:20'!
testStubReturnsNil

	self mock stub: #add:.
	self assert: ((self mock add: 1) = nil).
	self assert: self mock mockedObject isEmpty.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:15'!
testStubbedMessages

	self mock stub: #add:.
	self deny: (self mock stubbedMessages isEmpty).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:47'!
testUnmock

	self mock unmock.
	self assert: self mock isCollection.! !

Object subclass: #OrcaMock
	instanceVariableNames: 'mockedObject receivedMessages stubbedMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaMock class methodsFor: 'instance creation' stamp: 'hk 5/3/2011 07:46'!
for: anObject

	^ self new mockedObject: anObject! !

!OrcaMock class methodsFor: 'instance creation' stamp: 'hk 5/18/2011 23:15'!
forClass: aClass

	^ self new mockedObject: aClass basicNew! !

!OrcaMock methodsFor: 'mocking' stamp: 'hk 5/3/2011 09:43'!
doesNotUnderstand: aMessage

	self receivedMessages add: aMessage.
	(self stubs: aMessage)
		ifTrue: [ ^ (self stubbedMessages at: aMessage selector) value ]
		ifFalse: [ aMessage sendTo: self mockedObject ].! !

!OrcaMock methodsFor: 'initialization' stamp: 'hk 5/3/2011 09:37'!
initialize

	self
		receivedMessages: OrderedCollection new;
		stubbedMessages: Dictionary new.! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:46'!
mockedObject
	^ mockedObject! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:46'!
mockedObject: anObject
	mockedObject := anObject! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:20'!
received: aMessage

	self assert: aMessage isSymbol.
	^ self received: aMessage atLeast: 1! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:10'!
received: aMessage atLeast: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size >= aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:21'!
received: aMessage atMost: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size <= aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:11'!
received: aMessage times: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size = aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 10:20'!
received: aMessage withArgs: arguments

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each |
		each selector = aMessage
		and: [ each arguments = arguments ]
		]) notEmpty! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:58'!
receivedMessages
	^ receivedMessages! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:58'!
receivedMessages: anObject
	receivedMessages := anObject! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:38'!
stub: aMessage

	self stubbedMessages at: aMessage put: nil.! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:40'!
stub: aMessage andReturn: aBlock

	self stubbedMessages at: aMessage put: aBlock.! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:37'!
stubbedMessages
	^ stubbedMessages! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:37'!
stubbedMessages: anObject
	stubbedMessages := anObject! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:42'!
stubs: aMessage

	^ self stubbedMessages includesKey: aMessage selector! !

!OrcaMock methodsFor: 'mocking' stamp: 'hk 5/3/2011 07:57'!
unmock

	| temp |
	temp := self mockedObject.
	self mockedObject: nil.
	self become: temp.! !

OrcaWidget subclass: #OrcaClientSideTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

OrcaClientSideTestRunner class
	instanceVariableNames: 'dispatcher testResults clientConnectionSemaphore testResultSemaphore currentSession hasToWaitForPopup'!

OrcaClientSideTestRunner class
	instanceVariableNames: 'dispatcher testResults clientConnectionSemaphore testResultSemaphore currentSession hasToWaitForPopup'!

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'sw 5/24/2011 13:55'!
blankDocumentPath

	^ '/testing/file/documents/blank.html'! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
clientConnectionSemaphore
	^ clientConnectionSemaphore! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
clientConnectionSemaphore: anObject
	clientConnectionSemaphore := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/24/2011 10:57'!
currentSession
	^ currentSession! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/24/2011 10:57'!
currentSession: anObject
	currentSession := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
dispatcher
	^ dispatcher! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'hk 5/18/2011 10:25'!
dispatcher: anObject
	dispatcher := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:26'!
ensureClientSideTestRunnerIsStarted

	| activeSessions |
	
	self dispatcher ifNil:  [ self startDispatcher ].
		
	activeSessions := OrcaClientSideTestSession allInstances 
		select: [ :each |
			each channel notNil and: [ each channel isAlive] 
		].
		
	activeSessions	isEmpty ifTrue:
		[ self runFireFox ].
	
	
	   
	
		
	! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/24/2011 14:51'!
hasToWaitForPopup
	^ hasToWaitForPopup! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/24/2011 14:51'!
hasToWaitForPopup: anObject
	hasToWaitForPopup := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
isOrcaRootComponent
	
	^ true! !

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'sw 5/17/2011 14:32'!
maxSecondsForTesting
	
	^ 60! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
orcaSessionClass 

	 ^OrcaClientSideTestSession! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
orcaTitle
	
	^ 'Testing is fun'! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'sw 5/25/2011 13:24'!
requiredClasses
	
	^ OrcaClientSideTestCase allSubclasses add: Dictionary; addAll: 
	 { Point . OrcaRemoteObjectsServerSideTest . TestResult . Set . LimitedWriteStream };
	yourself ! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:40'!
reset

	OrcaClientSideTestSession allInstancesDo: [ :each |
		each channel ifNotNil: [ each channel  released ] ].
	
	self
		stopDispatcher;
		startDispatcher.! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:28'!
runFireFox

	"CommandShell command: 'open /Applications/Firefox.app --args http://localhost:', OrcaTestRunner testPort , '/',  OrcaTestRunner uniquePath , '; exit'"
	CommandShell command: 'open ''http://localhost:', OrcaClientSideTestRunner testPort , '/',  OrcaClientSideTestRunner uniquePath , '''; exit'.
	
	self clientConnectionSemaphore: Semaphore new.
	(self clientConnectionSemaphore waitTimeoutSeconds: self secondsToWaitForFirefox) ifTrue: [
		" the Semaphore wasn't signaled" 
		TimedOut signal: 'The Browser isn''t responding' ].! !

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'hk 5/18/2011 10:26'!
secondsToWaitForFirefox

	^ 60
	
		
	! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'sw 5/24/2011 10:56'!
serverStartupClass! !

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'sw 5/25/2011 13:14'!
signalIncomingClientConnection.

	self clientConnectionSemaphore ifNotNil: 
		[ self clientConnectionSemaphore signal ]  ! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'sw 5/23/2011 15:38'!
start

	"Js Global st DEBUG: false."
	Js Global testRunner: (OrcaClientSideTestRunner new addToWorld; yourself).
	! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:27'!
startDispatcher
	
	Transcript show: 'The TestRunner Dispatcher is starting'; cr.
	self dispatcher: (OrcaDispatcher installOn: self testPort  withName: self name ).
	(OrcaDispatcher siteNamed: self name ) start.
	! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'sw 5/24/2011 10:56'!
startOnServer: aSession
	
	self currentSession: aSession.! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/18/2011 10:45'!
stopDispatcher
	
	self dispatcher ifNotNil: [ | site |
		Transcript show: 'The TestRunner Dispatcher is stopping'; cr.
		self dispatcher: nil.
		(site := OrcaDispatcher siteNamed: self name) ifNotNil: [
			SwazooServer singleton removeSite: site.
			]
		].! !

!OrcaClientSideTestRunner class methodsFor: 'configuration-testing' stamp: 'hk 5/18/2011 10:26'!
testPort

	^ 8886! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 11:28'!
testResultSemaphore
	^ testResultSemaphore! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 11:28'!
testResultSemaphore: anObject
	testResultSemaphore := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 12:11'!
testResults
	^ testResults! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:35'!
testResults: anObject

	testResults := anObject.
	self testResultSemaphore signal.
	^ true! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2011 11:27'!
testResultsFrom: aString
	| result testcase |
	
	result := OrcaTestResult new.
	testcase := OrcaClientSideTestCase new; selector: #foo.
	
	(aString = 'pass') 
		ifTrue: [result passedTestcases add: testcase].
	(aString = 'error') 
		ifTrue: [result erroneousTestcases add: testcase].
	(aString = 'failure') 
		ifTrue: [result failedTestcases add: testcase].

	^ result

	
	! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'sw 5/25/2011 10:27'!
testResultsFromClient 
	

	self testResultSemaphore: Semaphore new.
	self testResultSemaphore wait.
	^ self testResults! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'sw 5/25/2011 10:27'!
testResultsFromClient: aResult
	
	self testResults: aResult.
	self halt.
	self testResultSemaphore signal.
	
	^ true! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/17/2011 16:37'!
testResultsFromString
	| result testcase |
	
	result := OrcaTestResult new.
	testcase := OrcaClientSideTestCase new; selector: #foo.
	
	(self testResults = 'pass') 
		ifTrue: [result passedTestcases add: testcase].
	(self testResults = 'error') 
		ifTrue: [result erroneousTestcases add: testcase].
	(self testResults = 'failure') 
		ifTrue: [result failedTestcases add: testcase].

	^ result

	
	! !

!OrcaClientSideTestRunner class methodsFor: 'configuration' stamp: 'hk 5/18/2011 10:26'!
uniquePath

	^ 'testing'! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2011 08:18'!
waitForTestsResults

	self testResultSemaphore: Semaphore new.
	(self testResultSemaphore waitTimeoutSeconds: self maxSecondsForTesting)
	 	ifTrue: [ TimedOut signal: 'Browser doesn''t answer' ]
		ifFalse: [ ^ self testResultsFromString ]

	! !

!OrcaClientSideTestRunner methodsFor: 'running' stamp: 'sw 5/25/2011 10:13'!
executeTests: aCollectionOfTests
	
	| results |
	results := OrderedCollection new.
	
	aCollectionOfTests do: [ :eachAssociation |      
		results add: (self performTest: eachAssociation )				
	].

	self add: (OrcaText new text: '<br/>Sending result back.').
	self sendResults: results ! !

!OrcaClientSideTestRunner methodsFor: 'initialization' stamp: 'sw 5/23/2011 11:19'!
initialize

	super initialize.
	self
		add: (OrcaHeading new text: 'Test Runner')
	! !

!OrcaClientSideTestRunner methodsFor: 'running' stamp: 'sw 5/23/2011 13:09'!
performTest: anAssociation 
	
	| result testcase |
	testcase := (Js instanceFromClassNamed: anAssociation key) setTestSelector: anAssociation value.
	result := testcase runOnClientside.

	self add: (OrcaText new text: '<br/>' , anAssociation key, ' >> ', anAssociation value, ' with result: ', (self resultStringFor: result)   ).  
	
	^ result! !

!OrcaClientSideTestRunner methodsFor: 'disposable' stamp: 'hk 5/17/2011 19:47'!
resultStringFor: aTestResult

	| resultString |
	
	resultString:= 'pass'.	
	aTestResult hasFailures ifTrue: [
		resultString := 'failure'].
	aTestResult hasErrors ifTrue: [
		resultString := 'error'].
	^ resultString
	  
	! !

!OrcaClientSideTestRunner methodsFor: 'running' stamp: 'sw 5/25/2011 14:46'!
sendResults: results

	[ :testResults | OrcaClientSideTestRunner testResultsFromClient: testResults ] onServer value: (results first).
	! !

OrcaWidget subclass: #OrcaIframe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaIframe class methodsFor: 'as yet unclassified' stamp: 'sw 5/25/2011 09:43'!
htmlElementType 

	^ 'iframe'! !

!OrcaIframe methodsFor: 'as yet unclassified' stamp: 'sw 5/25/2011 09:47'!
onLoad: aBlock

	self node onload: aBlock ! !

!OrcaIframe methodsFor: 'as yet unclassified' stamp: 'sw 5/25/2011 09:46'!
source

	^ self node src! !

!OrcaIframe methodsFor: 'as yet unclassified' stamp: 'sw 5/25/2011 09:45'!
source: aURL

	self node src: aURL! !

OrcaWidget subclass: #OrcaPopup
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaPopup class methodsFor: 'configuration' stamp: 'hk 5/18/2011 16:05'!
htmlElementType

	^ 'window'! !

!OrcaPopup methodsFor: 'rendering' stamp: 'hk 5/18/2011 15:58'!
add: anObject

	self children add: anObject.
	self isVisible ifTrue: [ self append: anObject ].
	^ anObject! !

!OrcaPopup methodsFor: 'rendering' stamp: 'sw 5/23/2011 14:23'!
append: anObject

	self body appendChild value: anObject node.! !

!OrcaPopup methodsFor: 'rendering' stamp: 'sw 5/23/2011 11:37'!
body
	
	^ self window document body ! !

!OrcaPopup methodsFor: 'rendering' stamp: 'sw 5/23/2011 16:36'!
document
	
	^ self window document! !

!OrcaPopup methodsFor: 'initialization' stamp: 'hk 5/18/2011 15:50'!
initialize

	super initialize.
	self cssClass: 'pseudoElement'.! !

!OrcaPopup methodsFor: '*Orca-Testing' stamp: 'hk 5/18/2011 15:56'!
isVisible

	^ self window notNil! !

!OrcaPopup methodsFor: 'initialization' stamp: 'sw 5/24/2011 13:09'!
onLoad
	| currentWindow win |
	currentWindow := Js Global window.
	win := currentWindow open value: self source.
	currentWindow focus value.
	self window: win.
	self children do: [ :each | self append: each ].! !

!OrcaPopup methodsFor: 'accessing' stamp: 'hk 5/18/2011 16:05'!
source

	^ self node src! !

!OrcaPopup methodsFor: 'accessing' stamp: 'hk 5/18/2011 16:05'!
source: aUrl

	self node src: aUrl.! !

!OrcaPopup methodsFor: 'accessing' stamp: 'hk 5/18/2011 15:50'!
window
	^ window! !

!OrcaPopup methodsFor: 'accessing' stamp: 'hk 5/18/2011 15:50'!
window: anObject
	window := anObject! !

!OrcaWidget methodsFor: '*Orca-Testing' stamp: 'hk 5/18/2011 23:26'!
childrenOfClass: aClass

	^ self children select: [ :each | each class = aClass ]! !

!OrcaWidget methodsFor: '*Orca-Testing' stamp: 'hk 5/18/2011 23:27'!
has: aNumber childrenOfClass: aClass

	^ (self childrenOfClass: aClass) size = aNumber! !

!OrcaWidget methodsFor: '*Orca-Testing' stamp: 'hk 5/17/2011 19:37'!
hasChild: aWidget

	^ self children includes: aWidget! !

!OrcaWidget methodsFor: '*Orca-Testing' stamp: 'hk 5/18/2011 23:27'!
hasChildrenOfClass: aClass

	^ (self childrenOfClass: aClass) notEmpty! !

!OrcaWidget methodsFor: '*Orca-Testing' stamp: 'hk 5/24/2011 13:58'!
isVisible

	self node ifNil: [ ^ false ].
	^ (self node style display = 'none') not! !
